package b4a.moka7.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.moka7.example", "b4a.moka7.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.moka7.example", "b4a.moka7.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.moka7.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static Moka7.S7Client _plc = null;
public static Moka7.S7 _s7_constant = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _ip_address = null;
public anywheresoftware.b4a.objects.LabelWrapper _info = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn_info = null;
public anywheresoftware.b4a.objects.ButtonWrapper _leggi = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txt_risultato = null;
public anywheresoftware.b4a.objects.ButtonWrapper _scrivi = null;
public anywheresoftware.b4a.objects.ButtonWrapper _disconnect = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 44;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 45;BA.debugLine="SetLayout";
_setlayout();
 //BA.debugLineNum = 48;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 54;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 56;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 50;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 52;BA.debugLine="End Sub";
return "";
}
public static String  _btn_info_click() throws Exception{
Moka7.S7CpuInfo _cpuinfo = null;
 //BA.debugLineNum = 74;BA.debugLine="Sub btn_info_Click";
 //BA.debugLineNum = 75;BA.debugLine="Dim cpuinfo As S7CpuInfo";
_cpuinfo = new Moka7.S7CpuInfo();
 //BA.debugLineNum = 76;BA.debugLine="If plc.Connected = True Then";
if (_plc.Connected==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 77;BA.debugLine="If plc.GetCpuInfo(cpuinfo) = 0 Then";
if (_plc.GetCpuInfo(_cpuinfo)==0) { 
 //BA.debugLineNum = 78;BA.debugLine="info.Text=info.Text & Chr(13) & Chr(10) & \"Moduletype  Name : \" & cpuinfo.ModuleTypeName";
mostCurrent._info.setText((Object)(mostCurrent._info.getText()+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+"Moduletype  Name : "+_cpuinfo.ModuleTypeName()));
 //BA.debugLineNum = 79;BA.debugLine="info.Text=info.Text & Chr(13) & Chr(10) & \"Serial : \" & cpuinfo.SerialNumber";
mostCurrent._info.setText((Object)(mostCurrent._info.getText()+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+"Serial : "+_cpuinfo.SerialNumber()));
 //BA.debugLineNum = 80;BA.debugLine="info.Text=info.Text & Chr(13) & Chr(10) & \"AS Name : \" & cpuinfo.ASName";
mostCurrent._info.setText((Object)(mostCurrent._info.getText()+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+"AS Name : "+_cpuinfo.ASName()));
 //BA.debugLineNum = 81;BA.debugLine="info.Text=info.Text & Chr(13) & Chr(10) & \"Copyright : \" & cpuinfo.Copyright";
mostCurrent._info.setText((Object)(mostCurrent._info.getText()+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+"Copyright : "+_cpuinfo.Copyright()));
 //BA.debugLineNum = 82;BA.debugLine="info.Text=info.Text & Chr(13) & Chr(10) & \"Module Name : \" & cpuinfo.ModuleName";
mostCurrent._info.setText((Object)(mostCurrent._info.getText()+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+"Module Name : "+_cpuinfo.ModuleName()));
 }else {
 //BA.debugLineNum = 84;BA.debugLine="ToastMessageShow(\"Error\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error",anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 //BA.debugLineNum = 88;BA.debugLine="Msgbox(\"Cpu not connected\",\"Error\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Cpu not connected","Error",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 92;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
int _a = 0;
 //BA.debugLineNum = 60;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 61;BA.debugLine="Dim a As Int";
_a = 0;
 //BA.debugLineNum = 63;BA.debugLine="plc.SetConnectionType(s7_constant.PG)";
_plc.SetConnectionType((short) (_s7_constant.PG));
 //BA.debugLineNum = 64;BA.debugLine="If plc.ConnectTo(ip_address.Text,0,2) = 0 Then";
if (_plc.ConnectTo(mostCurrent._ip_address.getText(),(int) (0),(int) (2))==0) { 
 //BA.debugLineNum = 65;BA.debugLine="info.text=\"Connected\"";
mostCurrent._info.setText((Object)("Connected"));
 }else {
 //BA.debugLineNum = 67;BA.debugLine="info.text=\"Not Connected\"";
mostCurrent._info.setText((Object)("Not Connected"));
 };
 //BA.debugLineNum = 69;BA.debugLine="End Sub";
return "";
}
public static String  _button3_click() throws Exception{
 //BA.debugLineNum = 71;BA.debugLine="Sub Button3_Click";
 //BA.debugLineNum = 72;BA.debugLine="plc.disconnect";
_plc.Disconnect();
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _disconnect_click() throws Exception{
 //BA.debugLineNum = 129;BA.debugLine="Sub disconnect_Click";
 //BA.debugLineNum = 130;BA.debugLine="plc.disconnect";
_plc.Disconnect();
 //BA.debugLineNum = 131;BA.debugLine="info.Text=\"Disconnected\"";
mostCurrent._info.setText((Object)("Disconnected"));
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 24;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 28;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Private Button3 As Button";
mostCurrent._button3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private ip_address As EditText";
mostCurrent._ip_address = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Private info As Label";
mostCurrent._info = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Private btn_info As Button";
mostCurrent._btn_info = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Private Leggi As Button";
mostCurrent._leggi = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Private txt_risultato As EditText";
mostCurrent._txt_risultato = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Private scrivi As Button";
mostCurrent._scrivi = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Private disconnect As Button";
mostCurrent._disconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _leggi_click() throws Exception{
byte[] _risultato = null;
int _valore = 0;
long _word = 0L;
 //BA.debugLineNum = 93;BA.debugLine="Sub Leggi_Click";
 //BA.debugLineNum = 94;BA.debugLine="Dim risultato(10) As Byte";
_risultato = new byte[(int) (10)];
;
 //BA.debugLineNum = 95;BA.debugLine="Dim valore As Int";
_valore = 0;
 //BA.debugLineNum = 96;BA.debugLine="Dim word As Long";
_word = 0L;
 //BA.debugLineNum = 97;BA.debugLine="If plc.Connected = True Then";
if (_plc.Connected==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 98;BA.debugLine="If plc.ReadArea(s7_constant.S7AreaDB,10,0,2,risultato) = 0 Then";
if (_plc.ReadArea(_s7_constant.S7AreaDB,(int) (10),(int) (0),(int) (2),_risultato)==0) { 
 //BA.debugLineNum = 100;BA.debugLine="valore=s7_constant.GetShortAt(risultato,0)";
_valore = _s7_constant.GetShortAt(_risultato,(int) (0));
 //BA.debugLineNum = 101;BA.debugLine="word = Bit.AND(0xffff, valore)";
_word = (long) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (0xffff),_valore));
 //BA.debugLineNum = 102;BA.debugLine="txt_risultato.Text=word";
mostCurrent._txt_risultato.setText((Object)(_word));
 }else {
 //BA.debugLineNum = 106;BA.debugLine="Msgbox(\"Errore lettura db\",\"ERRORE\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Errore lettura db","ERRORE",mostCurrent.activityBA);
 };
 }else {
 //BA.debugLineNum = 110;BA.debugLine="ToastMessageShow(\"Plc not connected\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Plc not connected",anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 112;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim plc As S7Client";
_plc = new Moka7.S7Client();
 //BA.debugLineNum = 20;BA.debugLine="Dim s7_constant As S7";
_s7_constant = new Moka7.S7();
 //BA.debugLineNum = 22;BA.debugLine="End Sub";
return "";
}
public static String  _scrivi_click() throws Exception{
byte[] _data = null;
int _valore = 0;
 //BA.debugLineNum = 113;BA.debugLine="Sub scrivi_Click";
 //BA.debugLineNum = 114;BA.debugLine="Dim data(4) As Byte";
_data = new byte[(int) (4)];
;
 //BA.debugLineNum = 115;BA.debugLine="Dim valore As Int";
_valore = 0;
 //BA.debugLineNum = 116;BA.debugLine="If plc.Connected = True Then";
if (_plc.Connected==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 118;BA.debugLine="valore=txt_risultato.Text";
_valore = (int)(Double.parseDouble(mostCurrent._txt_risultato.getText()));
 //BA.debugLineNum = 119;BA.debugLine="s7_constant.SetShortAt(data,0,valore)";
_s7_constant.SetShortAt(_data,(int) (0),_valore);
 //BA.debugLineNum = 120;BA.debugLine="If plc.WriteArea(s7_constant.S7AreaDB,10,0,2,data) = 0 Then";
if (_plc.WriteArea(_s7_constant.S7AreaDB,(int) (10),(int) (0),(int) (2),_data)==0) { 
 //BA.debugLineNum = 121;BA.debugLine="ToastMessageShow(\"Write OK\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Write OK",anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 123;BA.debugLine="ToastMessageShow(\"Write not Ok\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Write not Ok",anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 //BA.debugLineNum = 126;BA.debugLine="ToastMessageShow(\"Plc not connected\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Plc not connected",anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 128;BA.debugLine="End Sub";
return "";
}
public static String  _setlayout() throws Exception{
int _t = 0;
double _temp = 0;
anywheresoftware.b4a.objects.ConcreteViewWrapper _view1 = null;
anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
 //BA.debugLineNum = 137;BA.debugLine="Sub SetLayout()";
 //BA.debugLineNum = 139;BA.debugLine="Dim t As Int";
_t = 0;
 //BA.debugLineNum = 140;BA.debugLine="Dim temp As Double";
_temp = 0;
 //BA.debugLineNum = 141;BA.debugLine="Dim view1 As View";
_view1 = new anywheresoftware.b4a.objects.ConcreteViewWrapper();
 //BA.debugLineNum = 142;BA.debugLine="Dim lbl As Label";
_lbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 143;BA.debugLine="temp = (Activity.Width/320)/Density";
_temp = (mostCurrent._activity.getWidth()/(double)320)/(double)anywheresoftware.b4a.keywords.Common.Density;
 //BA.debugLineNum = 145;BA.debugLine="For t = 0 To Activity.NumberOfViews - 1";
{
final int step93 = 1;
final int limit93 = (int) (mostCurrent._activity.getNumberOfViews()-1);
for (_t = (int) (0); (step93 > 0 && _t <= limit93) || (step93 < 0 && _t >= limit93); _t = ((int)(0 + _t + step93))) {
 //BA.debugLineNum = 146;BA.debugLine="Activity.GetView(t).Left = Activity.GetView(t).Left * temp";
mostCurrent._activity.GetView(_t).setLeft((int) (mostCurrent._activity.GetView(_t).getLeft()*_temp));
 //BA.debugLineNum = 147;BA.debugLine="Activity.GetView(t).top = Activity.GetView(t).top * temp";
mostCurrent._activity.GetView(_t).setTop((int) (mostCurrent._activity.GetView(_t).getTop()*_temp));
 //BA.debugLineNum = 148;BA.debugLine="Activity.GetView(t).Width = Activity.GetView(t).Width * temp";
mostCurrent._activity.GetView(_t).setWidth((int) (mostCurrent._activity.GetView(_t).getWidth()*_temp));
 //BA.debugLineNum = 149;BA.debugLine="Activity.GetView(t).Height = Activity.GetView(t).Height * temp";
mostCurrent._activity.GetView(_t).setHeight((int) (mostCurrent._activity.GetView(_t).getHeight()*_temp));
 //BA.debugLineNum = 150;BA.debugLine="view1 = Activity.GetView(t)";
_view1 = mostCurrent._activity.GetView(_t);
 }
};
 //BA.debugLineNum = 153;BA.debugLine="End Sub";
return "";
}
}
